require "time_seg/version"

require "time"

module TimeSeg
    extend self
    TIME = [:half, :hour, :day, :month, :year]


    TIME.each do |method|
        define_method "to_#{method}" do |time|
            time_convert(method, time)
        end
    end

    def get_day(time)

    end

    def to_cus(seg, time)
        time = Time.parse(time)
        if seg == 30
            if time.min > 30
                Time.new(time.year, time.mon, time.day, time.hour, 30)
            else
                Time.new(time.year, time.mon, time.day, time.hour)
            end
        elsif
            seg % 60 == 0
            seg = seg / 60
            Time.new(time.year, time.mon, time.day, (time.hour/seg)*seg)
        elsif seg % 60 ==30
            hour_plus_min = time.hour*60 + time.min
            if ((hour_plus_min/seg)*1.5).modulo(1) == 0.0
                min = 0
            else
                min = 30
            end
            Time.new(time.year, time.mon, time.day, ((hour_plus_min/seg)*1.5).to_i, min.to_i)
        else
            puts "This function can't deal with this type."
        end
    end

    def time_convert(method, time)
        time = Time.parse(time)
        case method
        when :half
            if time.min > 30
                Time.new(time.year, time.mon, time.day, time.hour, 30)
            else
                Time.new(time.year, time.mon, time.day, time.hour)
            end
        when :hour
            newTime = Time.new(time.year, time.mon, time.day, time.hour)
        when :day
            newTime = Time.new(time.year, time.mon, time.day)
        when :month
            newTime = Time.new(time.year, time.mon)
        when :year
            newTime = Time.new(time.year)
        end
    end

    def timeDivision(time, division)
        time = Time.parse(time)
        start_time = Time.new(1990)
        def year
            year = time.year
            start_year = start_time.year
            while start_year < year
                start_year = start_year + division.to_i
            end
            return start_year - division.to_i
        end
        # case type.to_s
        # when "year"
        # when "hour"

        # when "min"

        # when "sec"
        # else
        #     puts "Please input: year, day, hour, min, sec."
        # end
    end
end
